
	/***************************/
	/* MR branch specific code */
	/***************************/

const	MIN_BUILDERS = 2;		// the usual number of trucks that construct base structures
const	MAX_BUILDERS = 4;		// the maximum number of trucks that construct base structures
const	MIN_OILERS = 5;		// the usual number of trucks used for oil hunting
const	MAX_OILERS = 5;		// the maximum number of trucks used for oil hunting
const	MIN_DEFENDERS = 2;		// the minimum number of tanks before producing more trucks than necessary
const	DEFENSIVENESS = 7;		// regulates chance of spending money on defensive structures
var	PEACE_TIME = 0;		// the amount of minutes for free scouting (regrouping disabled, no defenses built)

const	THIS_AI_MAKES_CYBORGS = true;
const	THIS_AI_MAKES_VTOLS = true;

const	researchPath = [
	"R-Wpn-Flamer-Damage03",
	"R-Wpn-Flamer-ROF01",
	"R-Struc-Factory-Cyborg",
	"R-Struc-PowerModuleMk1",
	"R-Vehicle-Body05",
	"R-Struc-RepairFacility",
	"R-Defense-HvyFlamer",
	"R-Cyborg-Metals04",
	"R-Vehicle-Prop-Hover",
	"R-Vehicle-Body11",
	"R-Sys-Sensor-Tower02",
	"R-Cyborg-Armor-Heat02",
	"R-Struc-VTOLFactory",
	"R-Struc-VTOLPad-Upgrade02",
	"R-Wpn-Bomb03",
	"R-Wpn-Flamer-ROF03",
	"R-Vehicle-Body08",
	"R-Defense-MortarPit-Incenediary",
	"R-Wpn-Bomb04",
	"R-Vehicle-Body12",
	"R-Struc-Power-Upgrade03a",
	"R-Defense-PlasmiteFlamer",
	"R-Wpn-Flamer-Damage09",
	"R-Defense-PulseLas",
	"R-Vehicle-Body09",
	"R-Defense-Howitzer-Incenediary",
	"R-Wpn-Bomb-Accuracy03",
	"R-Vehicle-Body10",
	"R-Wpn-Bomb05",
	"R-Struc-Research-Upgrade09",
	"R-Wpn-Energy-ROF03",
	"R-Wpn-Energy-Damage03",
	"R-Cyborg-Metals09",
	"R-Cyborg-Armor-Heat09",
	"R-Struc-VTOLPad-Upgrade06",
	"R-Vehicle-Body14",
];

const	truckBodies = [
	"Body3MBT", // retaliation
	"Body2SUP", // leopard
	"Body4ABT", // bug
	"Body1REC", // viper
];

const	truckPropulsions = [
	"hover01", // hover
	"wheeled01", // wheels
];

const	tankBodies = [
[
	"Body10MBT", // vengeance
	"Body7ABT", // retribution
	"Body9REC", // tiger
	"Body12SUP", // mantis
	"Body11ABT", // python
	"Body6SUPP", // panther
	"Body8MBT", // scorpion
	"Body5REC", // cobra
],
];

const	tankPropulsions = [
	"hover01", // hover
	"HalfTrack", // half-track
];

const	vtolBodies = [
	"Body7ABT", // retribution
	"Body6SUPP", // panther
	"Body8MBT", // scorpion
	"Body5REC", // cobra
];

const	vtolPropulsions = [
	"V-Tol", // guess what ...
];

const	apWeapons = [
[
	"Laser2PULSEMk1", // pulse laser
	"Laser3BEAMMk1", // flashlight
	"PlasmiteFlamer", // plasmite
	"Flame2", // inferno
	"Flame1Mk1", // flamer
	"MG2Mk1", // tmg
	"MG1Mk1", // mg
],
];

const	atWeapons = apWeapons;

const	vtolWeapons = [
	"Bomb5-VTOL-Plasmite", // plasmite bombs
	"Bomb4-VTOL-HvyINC", // thermite bombs
	"Bomb3-VTOL-LtINC", // phosphor bombs
	"Bomb1-VTOL-LtHE", // cluster bombs
];

const	apCyborgStats = [
[
	["Cyb-Hvybod-PulseLsr","Cyb-Hvywpn-PulseLsr"], // super pulse
	["Cyb-Bod-Las1","Cyb-Wpn-Laser"], // flashlight
	["Cyb-Bod-Thermite", "Cyb-Wpn-Thermite"], // thermite
	["CyborgFlamerGrd", "CyborgFlamer01"], // flamer
],
];

const	atCyborgStats = apCyborgStats;

const	defenses = [
	"GuardTower-BeamLas", // pulse tower
	"Emplacement-PrisLas", // flashlight emplacement
	"Plasmite-flamer-bunker", // plasmite bunker
	"Tower-Projector", // inferno bunker
	"PillBox5", // flamer bunker
];

const	sensors = [
	"Sys-SensoTowerWS", // wide spectrum sensor
	"Sys-SensoTower02", // hardened sensor
	"Sys-SensoTower01", // sensor
];

const	artillery = [
	"Emplacement-Howitzer-Incenediary", // incendiary mortar
	"Emplacement-MortarPit-Incenediary", // incendiary mortar
];

// Flame personality doesn't invent anti-air defenses on its own, 
// but it uses them if they are suddenly available (eg., researched by teammates)
const antiair = [
	"P0-AASite-Laser", // stormbringer
	"P0-AASite-SAM2", // vindicator
	"AASite-QuadRotMg", // whirlwind
	"P0-AASite-SAM1", // avenger
	"P0-AASite-Sunburst", // sunburst
	"AASite-QuadBof", // flak cannon
	"AASite-QuadMg1", // hurricane
];


// Builds initial structures in the following order:
//     lab, factory, lab, lab, generator, generator, command center, factory, factory.
// Doesn't build the second factory until hovers are available.
// Then build extra structures if necessary.
// Also make sure we have at least one generator before our initial money runs out
function executeBuildOrder() {
	const	lab = "A0ResearchFacility";
	const	factory = "A0LightFactory";
	const	command = "A0CommandCentre";
	const	generator = "A0PowerGenerator";
	const	derrick = "A0ResourceExtractor";
	const	borgfac = "A0CyborgFactory";
	const	COMP_PROPULSION=3; // HACK: define it here until these constants are exposed to scripts
	var labCount = enumStruct(me, lab).length;
	var factoryCount = enumStruct(me, factory).length;
	var commandCount = enumStruct(me, command).length;
	var genCount = enumStruct(me, generator).length;
	var derrickCount = enumStruct(me, derrick).length;
	var borgCount = enumStruct(me, borgfac).length;
	var vtolCount = enumStruct(me, vtolfac).length;
	if (genCount < 2 && playerPower(me) < EXTREME_LOW_POWER && isStructureAvailable(generator,me))
		buildBasicStructure(generator);
	else if (labCount < 1 && isStructureAvailable(lab,me))
		buildBasicStructure(lab);
	else if (factoryCount < 1 && isStructureAvailable(factory,me))
		buildBasicStructure(factory);
	else if (labCount < 3 && isStructureAvailable(lab,me))
		buildBasicStructure(lab);
	else if ((genCount < 2) && isStructureAvailable(generator,me))
		buildBasicStructure(generator);
	else if (isStructureAvailable(command,me))
		buildBasicStructure(command);
	else if (factoryCount < 3 && isStructureAvailable(factory,me) && componentAvailable(COMP_PROPULSION,"hover01"))
		buildBasicStructure(factory);
	else if (borgCount < 4 && isStructureAvailable(borgfac,me) && playerPower(me) > EXTREME_LOW_POWER) 
		buildBasicStructure(borgfac);
	else if (vtolCount < 2 && isStructureAvailable(vtolfac,me)) 
		buildBasicStructure(vtolfac);
	else
		keepBuildingThings();
}


	/*************/
	/* Variables */
	/*************/
	
var	UNUSUAL_SITUATION = false;		
// UNUSUAL_SITUATION is true if we are participating in challenge of some sort;
// this is detected at eventStartLevel and does some tweaks to the AI to make it
// behave more campaign-like during challenges

const	MIN_GROUPS = 2;		// the maximum number of combat groups
const	MAX_GROUPS = 6;		// the maximum number of combat groups
var	NUM_GROUPS = MIN_GROUPS;

var	MAX_WARRIORS = 12;		// the maximum number of droids in a group
var	NUM_WARRIORS = 8;		// the number of battle droids to maintain in a single group
var	MIN_WARRIORS = 7;		// the number of battle droids necessary to engage in combat
const	NO_WARRIORS_AT_ALL = 3;		// the number of droids that doesn't make a cluster yet

const	MIN_VTOL_GROUPS = 2;		// the maximum number of VTOL groups
const	MAX_VTOL_GROUPS = 6;		// the maximum number of VTOL groups
var	NUM_VTOL_GROUPS = MIN_VTOL_GROUPS;

const	MIN_VTOLS = 4;		// the minimum number of vtols to have in attack group before attack
const	NUM_VTOLS = 6;		// the minimum number of vtols to have in attack group before attack
const	MAX_VTOLS = 8;		// the minimum number of vtols to have in attack group before attack

var	ABS_MIN_WARRIORS = 10;		// the ultimate number of battle droids necessary to engage in combat
var	ABS_NUM_WARRIORS = 16;		// the ultimate number of battle droids to maintain in a single group
var	ABS_MAX_WARRIORS = 20;		// the ultimate number of battle droids necessary for an attack

const	ABS_MAX_TRUCKS = 10;			// try not to make too many trucks

const	MAX_DISPERSE = 4; 		// the maximum dispersion of the attack group
const	RETREAT_AT = 40;		// send the unit for repair if it has this much hit point percent left

const	NUM_VTOL_PADS = 2;		// this many vtols per vtol pad are allowed
const	BASE_SIZE = 20;		// range of alertness
const	DEFS_PER_SENSOR = 3;		// regulates chance of constructing a sensor instead of defensive tower
const	DEFS_PER_ARTY = 1;		// regulates chance of constructing an artillery site instead of defensive tower

var	RATE_AP = 2;		// these values affect the amount of a certain weapon class in the mix
var	RATE_AT = 1;

const	LOW_POWER = 700;		//decrease ambitions when power is below this level
const	EXTREME_LOW_POWER = 300;

const	lab = "A0ResearchFacility";
const	factory = "A0LightFactory";
const	command = "A0CommandCentre";
const	generator = "A0PowerGenerator";
const	derrick = "A0ResourceExtractor";
const	borgfac = "A0CyborgFactory";
const	vtolfac = "A0VTolFactory1";
const	vtolpad = "A0VtolPad";
const	satlink = "A0Sat-linkCentre";
const	lassat = "A0LasSatCommand";
const	oilres = "OilResource";
const	cbtower = "Sys-CB-Tower01";
const	repair = "A0RepairCentre3";

const	pmod = "A0PowMod1";
const	fmod = "A0FacMod1";
const	rmod = "A0ResearchModule1";

const	attackTargets = [
	borgfac,
	factory,
	vtolfac,
	derrick,
	lassat,
];

var	builderGroup, oilerGroup, battleGroup = [], vtolGroup = [];
var	groupEnemy = new Array(NUM_GROUPS);

const	STATUS_NORMAL=0, STATUS_PANIC=1, STATUS_UNDER_ARTY_FIRE=2;
var	status=STATUS_NORMAL;
var	statusX, statusY, statusTime;

	/**************/
	/* Procedures */
	/**************/
	
// random integer between 0 and max-1 (for convenience)
function random(max) {
	return Math.floor(Math.random() * max);
}

// returns true iff gameTime is less than n minutes
function earlyGame(n) {
	return (gameTime < n*60000);
}

// this AI doesn't cheat yet
function cheat() {
	switch(difficulty) {
		case INSANE:
			break;
		case HARD:
			break;
		case MEDIUM:
			break;
		case EASY:
			break;
	}
}

// makes attack groups bigger
function becomeHarder() {
	if (MIN_WARRIORS < ABS_MIN_WARRIORS) 
		MIN_WARRIORS += 1;
	if (NUM_WARRIORS < ABS_NUM_WARRIORS) 
		NUM_WARRIORS += 1;
	if (MAX_WARRIORS < ABS_MAX_WARRIORS) 
		MAX_WARRIORS += 1;
}

// checks if we can design tanks and research towers
function iHaveCC() {
	var list=enumStruct(me,command);
	if (list.length == 0)
		return false;
	if (list[0].status == BEING_BUILT)
		return false;
	return true;
}

// adapt unit choices to enemy choices
// for example, build machineguns against borgs and rockets against tanks
function adapt() {
	var enemyBorgCount = 0, enemyTankCount = 0, enemyVtolCount = 0;;
	for (var i=0; i<maxPlayers; ++i)
		if (isAnEnemy(i)) {
			enemyBorgCount+=enumDroid(i,DROID_CYBORG).length;
			enemyBorgCount+=enumDroid(i,DROID_REPAIR).length;
			enemyBorgCount+=enumDroid(i,DROID_CONSTRUCT).length;
			var tanks = enumDroid(i,DROID_WEAPON);
			enemyTankCount+=tanks.length;
			// FIXME: disabled until i find a way to count own AA
			/*for (var i=0; i<tanks.length; ++i)
				if (isVTOL(tanks[i]))
					++enemyVtolCount;*/
		}
	var myATCount = 0, myAPCount = 0;
	var list;
	list=enumDroid(me, DROID_WEAPON);
	for (var i=0; i<list.length; ++i) {
		if (list[i].name.indexOf("AP") != -1)
			++myAPCount;
		if (list[i].name.indexOf("AT") != -1)
			++myATCount;
	}
	list=enumDroid(me, DROID_CYBORG);
	for (var i=0; i<list.length; ++i) {
		if (list[i].name.indexOf("AP") != -1)
			++myAPCount;
		if (list[i].name.indexOf("AT") != -1)
			++myATCount;
	}
	if (myATCount*enemyBorgCount > myAPCount*enemyTankCount)
		RATE_AT = 1, RATE_AP = 5;
	else 
		RATE_AT = 5, RATE_AP = 1;
	// FIXME: unused so far, see above
	//RATE_AA = enemyVtolCount / 2;
	
}

// return a droid to base
function forceReturnToBase(droid) {
	orderDroidLoc(droid, DORDER_MOVE, startPositions[me].x, startPositions[me].y);
}

// return a droid to base if not in base yet
function returnToBase(droid) {
	if (distBetweenTwoPoints(droid.x, droid.y, startPositions[me].x, startPositions[me].y) > BASE_SIZE)
		forceReturnToBase(droid);
}

// estimates enemy activity in an area
function dangerLevel(x,y) {
	var badGuys=0;
	for (var enemy=0; enemy<maxPlayers; ++enemy) if (isAnEnemy(enemy)) {
		var list = enumDroid(enemy);
		for (var i=0; i<list.length; ++i) 
			if (distBetweenTwoPoints(list[i].x,list[i].y,x,y) <= BASE_SIZE/2)
				++badGuys;
		var list = enumStruct(enemy);
		for (var i=0; i<list.length; ++i) 
			if (list[i].stattype==DEFENSE)
				if (distBetweenTwoPoints(list[i].x,list[i].y,x,y) <= BASE_SIZE/2)
					++badGuys;
	}
	return badGuys+(safeDest(me,x,y)?0:1);
}

// checks if a droid needs to be sent for repair
function needsRepair(droid) {
	if (droid.health < RETREAT_AT) 
		return true;
	if (droid.health >= 99)
		return false;
	var centers = enumStruct(me, repair);
	if (centers.length == 0)
		return false;
	for (var i=0; i<centers.length; ++i) {
		if (distBetweenTwoPoints(centers[i].x,centers[i].y,droid.x,droid.y) < 3)
			return true;
	}
	return false;
}

// sends a droid to a nearest repair center if necessary;
// returns true iff the droid was actually sent
function sendForRepair(droid) {
	if (!needsRepair(droid))
		return false;
	var centers = enumStruct(me, repair);
	if (centers.length == 0)
		return false;
	var idx=0, dist=Infinity;
	for (var i=0; i<centers.length; ++i) {
		var d=distBetweenTwoPoints(centers[i].x,centers[i].y,droid.x,droid.y);
		if (d<dist) {
			idx=i;
			dist=d;
		}
	}
	return orderDroidLoc(droid,DORDER_MOVE,centers[idx].x,centers[idx].y);
}

// checks if any droids around need to be sent for repair
function sendAllForRepair() {
	var list;
	for (var gr=0; gr<NUM_GROUPS; ++gr) {
		list=enumGroup(battleGroup[gr]);
		for (var i=0; i<list.length; ++i) 
			sendForRepair(list[i]);
	}
}


/* Status manipulations */	


function setStatus(newStatus) {
	status=newStatus;
	switch(status) {
		case STATUS_NORMAL:
			statusTime=0;
			break;
		case STATUS_UNDER_ARTY_FIRE:
			statusTime=3;
			break;
		case STATUS_PANIC:
			statusTime=5;
			break;
	}
}

function updateStatus() {
	var goodGuys=0, badGuys=0;
	for (var enemy=0; enemy<maxPlayers; ++enemy) {
		var list = enumDroid(enemy);
		for (var i=0; i<list.length; ++i) 
			if (distBetweenTwoPoints(list[i].x,list[i].y,startPositions[me].x,startPositions[me].y) <= BASE_SIZE) {
				if (isAnEnemy(enemy))
					++badGuys;
				else
					++goodGuys;
			}
		
	}
	if (badGuys>goodGuys) {
		setStatus(STATUS_PANIC);
		return;
	}
	if (statusTime>0)
		--statusTime;
	else
		setStatus(STATUS_NORMAL);
}


/* Constructing the base */


// order the builderGroup to build some base structure somewhere
function buildBasicStructure(struct) {
	if (typeof(struct)=="undefined")
		return;
	var droidlist = enumGroup(builderGroup);
	if (droidlist.length == 0) 
		return false;
	var loc = pickStructLocation(
		droidlist[0], 
		struct, 
		startPositions[me].x, 
		startPositions[me].y, 
		0
	);
	if (typeof(loc)=="undefined")
		return false;
	if (dangerLevel(loc.x,loc.y)>0)
		return false;
	for (var i=0; i<droidlist.length; ++i)
		if (droidlist[i].order != DORDER_BUILD) 
			if (droidlist[i].order != DORDER_HELPBUILD) 
				if (droidlist[i].order != DORDER_LINEBUILD)
					orderDroidBuild(droidlist[i], DORDER_BUILD, struct, loc.x, loc.y);
}

// build a specific module
function buildModule(struct, moduleType) {
	if (typeof(struct)=="undefined")
		return;
	if (!isStructureAvailable(moduleType, me))
		return false;
	var droidlist = enumGroup(builderGroup);
	for (var i=0; i<droidlist.length; ++i)	
		if (droidlist[i].order != DORDER_BUILD) 
			if (droidlist[i].order != DORDER_HELPBUILD) 
				if (droidlist[i].order != DORDER_LINEBUILD)
					if (orderDroidBuild(droidlist[i], DORDER_BUILD, moduleType, struct.x, struct.y))
						return true;
	return false;
}

// build some defensive structure somewhere near (x,y)
function buildTower(x,y,list) {
	if (dangerLevel(x,y)>2)
		return;
	var droidlist = enumGroup(oilerGroup);
	if (droidlist.length == 0 || list.length == 0) 
		return false;
	var tower;
	for (var i=0; i<list.length; ++i)
		if (isStructureAvailable(list[i],me)) {
			tower=list[i];
			break;
		}
	if (typeof(tower)=="undefined")
		return false;
	var loc = pickStructLocation(droidlist[0], tower, x, y, 0);
	if (typeof(loc)=="undefined")
		return false;
	if (dangerLevel(loc.x,loc.y)>2)
		return false;
	for (var i=0; i<droidlist.length; ++i)	
		if (droidlist[i].order != DORDER_BUILD) 
			if (droidlist[i].order != DORDER_HELPBUILD) 
				if (droidlist[i].order != DORDER_LINEBUILD)
					if (orderDroidBuild(droidlist[i], DORDER_BUILD, tower, loc.x, loc.y))
						return true;
}

// protect things
function buildDefenses() {
	if (earlyGame(PEACE_TIME))
		return false;
	var list=enumStruct(me,derrick);
	if (list.length == 0)
		return;
	var i=random(list.length);
	if (isStructureAvailable(repair,me) && !UNUSUAL_SITUATION) {
		var repairList=[];
		repairList[0]=repair;
		buildTower(list[i].x,list[i].y,repairList);
		return;
	}
	if (!iHaveCC()) 
		return;
	if (random(DEFS_PER_ARTY+1)>0) {
		if (random(DEFS_PER_SENSOR+1)>0)
			buildTower(list[i].x,list[i].y,defenses);
		else
			buildTower(list[i].x,list[i].y,sensors);
	} else {
		buildTower(startPositions[me].x,startPositions[me].y,artillery);
	}
}

// expand the base by building more labs and factories
function keepBuildingThings() {
	var genCount = enumStruct(me, generator).length;
	var cbCount = enumStruct(me, cbtower).length;
	var derrickCount = enumStruct(me, derrick).length;
	if ((genCount < 2 || derrickCount - 4*genCount > 0) && isStructureAvailable(generator,me) && !UNUSUAL_SITUATION) {
		buildBasicStructure(generator);
		return;
	}
	if (THIS_AI_MAKES_VTOLS) {
		if (enumStruct(me, vtolfac).length > 0) {
			var vtolList = enumDroid(me, DROID_WEAPON);
			var vtolCount=0;
			for (var i=0; i<vtolList.length; ++i)
				if (isVTOL(vtolList[i]))
					++vtolCount;
			var padCount = enumStruct(me, vtolpad).length;
			if (NUM_VTOL_PADS*padCount < vtolCount && isStructureAvailable(vtolpad,me)) {
				buildBasicStructure(vtolpad);
				return;
			}
		}
	}
	if (cbCount < 3 && isStructureAvailable(cbtower,me)) 
		buildBasicStructure(cbtower);
	else if (isStructureAvailable(satlink,me))
		buildBasicStructure(satlink);
	else if (isStructureAvailable(lassat,me))
		buildBasicStructure(lassat);
	else {
		if (random(DEFENSIVENESS+1) > 0 || playerPower(me) > LOW_POWER) {
			buildDefenses();
		} 
		if (playerPower(me) > LOW_POWER && !UNUSUAL_SITUATION) {
			var list=[];
			if (isStructureAvailable(factory,me))
				list[list.length]=factory;
			if (isStructureAvailable(lab,me))
				list[list.length]=lab;
			if (isStructureAvailable(borgfac,me) && THIS_AI_MAKES_CYBORGS)
				list[list.length]=borgfac;
			if (isStructureAvailable(vtolfac,me) && THIS_AI_MAKES_VTOLS)
				list[list.length]=vtolfac;
			buildBasicStructure(list[random(list.length)]);
		}
	}	
}

// finish buildings that were never finished yet
function buildIncompleteBuildings() {
	var droidlist; 
	var list = enumStruct(me);
	for (j=0; j<list.length; ++j) {
		if (list[j].status == BEING_BUILT) 
			if (dangerLevel(list[j].x,list[j].y)<=0) {
			droidlist=enumGroup(oilerGroup);
			for (var i=0; i<droidlist.length; ++i)	
				if (droidlist[i].order != DORDER_BUILD) 
					if (droidlist[i].order != DORDER_HELPBUILD) 
						if (droidlist[i].order != DORDER_LINEBUILD)
							orderDroidObj(droidlist[i], DORDER_HELPBUILD, list[j]);
			if (list[j].stattype != RESOURCE_EXTRACTOR && list[j].stattype != DEFENSE) {
				droidlist=enumGroup(builderGroup);
				for (var i=0; i<droidlist.length; ++i)	
					if (droidlist[i].order != DORDER_BUILD) 
						if (droidlist[i].order != DORDER_HELPBUILD) 
							if (droidlist[i].order != DORDER_LINEBUILD)
								orderDroidObj(droidlist[i], DORDER_HELPBUILD, list[j]);
			}
		}
	}
}

// build different sorts of modules
function upgradeStructures() {
	var list;
	list = enumStruct(me, generator);
	for (var i=0; i<list.length; ++i) 
		if (list[i].modules < 1) 
			if (buildModule(list[i], pmod)) 
				return;
	// don't build factory and research modules too much
	// if low on power
	if (playerPower(me) < LOW_POWER)
		if (random(5)>0)
			return;
	list = enumStruct(me, factory);
	for (var i=0; i<list.length; ++i) 
		if (list[i].modules < 2) 
			if (buildModule(list[i], fmod)) 
				return;
	list = enumStruct(me, lab);
	for (var i=0; i<list.length; ++i) 
		if (list[i].modules < 1) 
			if (buildModule(list[i], rmod)) 
				return;
	list = enumStruct(me, vtolfac);
	for (var i=0; i<list.length; ++i) 
		if (list[i].modules < 1) 
			if (buildModule(list[i], fmod)) 
				return;
}

// order free oil-oriented trucks to build oil derricks
function huntForOil() {
	var droidlist = enumGroup(oilerGroup);
	var oillist = enumFeature(-1, oilres);
	for (var j=0; j<oillist.length; ++j) 
		oillist[j].ordered=false;
	for (var i=0; i<droidlist.length; ++i) if (droidlist[i].order != DORDER_BUILD) {
		var range1=999;
		var k=-1;
		for (var j=0; j<oillist.length; ++j) 
			if (!oillist[j].ordered)
				if (droidCanReach(droidlist[i],oillist[j].x,oillist[j].y))
					if (dangerLevel(oillist[j].x,oillist[j].y)<=0) {
						var range2=distBetweenTwoPoints(droidlist[i].x, droidlist[i].y, oillist[j].x, oillist[j].y);
						if (range2<range1) {
							range1=range2;
							k=j;
						}
					}
		if (k!=-1) {
			orderDroidBuild(droidlist[i], DORDER_BUILD, derrick, oillist[k].x, oillist[k].y);
			//make sure not too many trucks build the same oil
			oillist[k].ordered=true;
		} else {
			//return to base if no oils are available for capturing
			returnToBase(droidlist[i]);
		}
	}

}


/* Researching technologies */	


// come up with something
function doResearch() {
	var lablist=enumStruct(me, lab);
	var ok;
	for (var i=0; i<lablist.length; ++i) if (structureIdle(lablist[i])) {
		// even though pursueResearch() accepts lists as a second parameter,
		// this cycle makes following the exact research path more precise.
		for (var j=0; j<researchPath.length && !ok; ++j)
			if (pursueResearch(lablist[i],researchPath[j]))
				break;
	}
}


/* Producing droids */	


// finds out which battle group contains this tank
function groupOfTank(tank) {
	for (i=0; i<NUM_GROUPS; ++i)
		if (tank.group = battleGroup[i])
			return i;
}

// pick a suitable group for a new-born truck
function addTruckToSomeGroup(truck) {
	if (groupSize(builderGroup) < MIN_BUILDERS)
		groupAddDroid(builderGroup,truck);
	else if (groupSize(oilerGroup) < MIN_OILERS)
		groupAddDroid(oilerGroup,truck);
	else if (groupSize(builderGroup) < MAX_BUILDERS)
		groupAddDroid(builderGroup,truck);
	else if (groupSize(oilerGroup) < MAX_OILERS)
		groupAddDroid(oilerGroup,truck);
	else if (random(2)==0)
		groupAddDroid(builderGroup,truck);
	else
		groupAddDroid(oilerGroup,truck);
}

// pick a suitable group for a new-born tank
function addTankToSomeGroup(tank) {
	for (var i=0; i<NUM_GROUPS; ++i)
		if (groupSize(battleGroup[i])<NUM_WARRIORS) {
			groupAddDroid(battleGroup[i], tank);
			return;
		}
	for (var i=0; i<NUM_GROUPS; ++i)
		if (groupSize(battleGroup[i])<MAX_WARRIORS) {
			groupAddDroid(battleGroup[i], tank);
			return;
		}
	if (NUM_GROUPS < MAX_GROUPS) {
		battleGroup[NUM_GROUPS]=newGroup();
		groupAddDroid(battleGroup[NUM_GROUPS], tank);
		groupEnemy[NUM_GROUPS]=findEnemy();
		++NUM_GROUPS;
		return;
	}
	groupAddDroid(battleGroup[random(NUM_GROUPS)], tank);
}

// pick a suitable group for a new-born vtol
function addVtolToSomeGroup(vtol) {
	for (var i=0; i<NUM_VTOL_GROUPS; ++i)
		if (groupSize(vtolGroup[i])<NUM_VTOLS) {
			groupAddDroid(vtolGroup[i], vtol);
			return;
		}
	for (var i=0; i<NUM_VTOL_GROUPS; ++i)
		if (groupSize(vtolGroup[i])<MAX_VTOLS) {
			groupAddDroid(vtolGroup[i], vtol);
			return;
		}
	if (NUM_VTOL_GROUPS < MAX_VTOL_GROUPS) {
		vtolGroup[NUM_VTOL_GROUPS]=newGroup();
		groupAddDroid(vtolGroup[NUM_VTOL_GROUPS], vtol);
		++NUM_VTOL_GROUPS;
		return;
	}
	groupAddDroid(vtolGroup[random(NUM_VTOL_GROUPS)], vtol);
}

// remove some groups if too many groups are on the field
function tooManyGroups() {
	if (NUM_GROUPS <= MIN_GROUPS) 
		return;
	var smallestIdx, smallestSize=Infinity, largestSize=0;
	for (var i=0; i<NUM_GROUPS; ++i) {
		var size=groupSize(battleGroup[i]);
		if (size<smallestSize) {
			smallestIdx = i;
			smallestSize - size;
		}
		if (size>largestSize)
			largestSize = size;
	}
	if (largestSize >= MIN_WARRIORS) 
		return;
	var list=enumGroup(battleGroup[smallestIdx]);
	--NUM_GROUPS;
	battleGroup[smallestIdx]=battleGroup[NUM_GROUPS];
	for (var i=0; i<list.length; ++i) {
		addTankToSomeGroup(list[i]);
	}
}

// order some factory to build a truck
function produceTrucks() {
	if (status==STATUS_PANIC)
		return false;
	// do we actually need more trucks?
	if (playerPower(me)<LOW_POWER || enumDroid(me,DROID_WEAPON).length < MIN_DEFENDERS)
		if (groupSize(oilerGroup) >= MAX_OILERS && groupSize(builderGroup) >= MAX_BUILDERS)
			return false;
	if (groupSize(oilerGroup) >= MIN_OILERS && groupSize(builderGroup) >= MIN_BUILDERS)
		if (enumDroid(me,DROID_WEAPON).length < MIN_DEFENDERS)
			return false;
	if (groupSize(oilerGroup)+groupSize(builderGroup)>=ABS_MAX_TRUCKS)
		return false;
	var factories = enumStruct(me, factory);
	for (var i=0; i<factories.length; ++i) {
		var struct=factories[i];
		if (structureIdle(struct)) {
			return buildDroid(struct, "Truck", truckBodies, truckPropulsions, "", DROID_CONSTRUCT, "Spade1Mk1");
		}
	}
	// cyborg engineers can't be produced at all in v3.1, see http://developer.wz2100.net/ticket/3133
	if (version.indexOf("3.1") == -1) {
		if (groupSize(builderGroup) < MIN_BUILDERS) {
			var factories = enumStruct(me, borgfac);
			for (var i=0; i<factories.length; ++i) {
				var struct=factories[i];
				if (structureIdle(struct)) {
					return buildDroid(struct, "Truck", "Cyb-Bod-ComEng", "CyborgLegs", "", DROID_CONSTRUCT, "CyborgSpade");
				}
			}
		}
	}
	return false;
}

// order idle factories to build tanks
function produceTanks() {
	if (produceTrucks()) 
		return;
	if (!iHaveCC()) 
		return;
	var factories = enumStruct(me, factory);
	var iap=random(apWeapons.length);
	var iat=random(atWeapons.length);
	var ib=random(tankBodies.length);
	for (var i=0; i<factories.length; ++i) {
		var struct=factories[i];
		if (structureIdle(struct)) {
			if (random(RATE_AP+RATE_AT) < RATE_AT) {
				if (!buildDroid(struct, "AT Tank", tankBodies[ib], tankPropulsions, "", DROID_WEAPON, atWeapons[iat]))
					buildDroid(struct, "AP Tank", tankBodies[ib], tankPropulsions, "", DROID_WEAPON, apWeapons[iap]);
			} else
				if (!buildDroid(struct, "AP Tank", tankBodies[ib], tankPropulsions, "", DROID_WEAPON, apWeapons[iap]))
					buildDroid(struct, "AT Tank", tankBodies[ib], tankPropulsions, "", DROID_WEAPON, atWeapons[iat]);
		}
	}
}

// order idle borg factories to build borgs
function produceCyborgs() {
	if (produceTrucks()) 
		return;
	if (!THIS_AI_MAKES_CYBORGS) 
		return;
	var factories = enumStruct(me, borgfac);
	var iap=random(apCyborgStats.length);
	var iat=random(atCyborgStats.length);
	for (var i=0; i<factories.length; ++i) {
		var struct=factories[i];
		if (structureIdle(struct)) {	
			if (random(RATE_AP+RATE_AT) < RATE_AP) {
				for (var j=0; j<apCyborgStats[iap].length; ++j) {
					var s = apCyborgStats[iap][j];
					if (buildDroid(struct, "AP Cyborg", s[0], "CyborgLegs", "", DROID_CYBORG, s[1]))
						break;
				}
			} else {
				for (var j=0; j<atCyborgStats[iat].length; ++j) {
					var s = atCyborgStats[iat][j];
					if (buildDroid(struct, "AT Cyborg", s[0], "CyborgLegs", "", DROID_CYBORG, s[1]))
						break;
				}
			}
		}
	}
}

// order idle vtol factories to build vtols
function produceVtols() {
	if (!THIS_AI_MAKES_VTOLS) 
		return;
	var factories = enumStruct(me, vtolfac);
	for (var i=0; i<factories.length; ++i) {
		var struct=factories[i];
		if (structureIdle(struct)) 	
			buildDroid(struct, "VTOL", vtolBodies, vtolPropulsions, "", DROID_WEAPON, vtolWeapons);
	}
}

// get back to work!
function produceDroids() {
	// don't run out of power
	if (playerPower(me) < EXTREME_LOW_POWER && enumStruct(me, generator).length < 2)
		return;
	produceTrucks();
	queue("produceTanks");
	queue("produceCyborgs");
	queue("produceVtols");
}


/* Attacking the enemy */


// checks if the enemy is actually an threat
function isAnEnemy(enemy) {
	if (typeof(enemy)=="undefined")
		return false;
	if (allianceExistsBetween(me, enemy)) 
		return false;
	for (var i=0; i<attackTargets.length; ++i) 
		if (enumStruct(enemy, attackTargets[i]).length > 0) 
			return true;
	if (enumDroid(enemy).length > 0)
		return true;
	return false;
}

function nextEnemy(enemy) {
	var i=enemy;
	do {
		++i;
		if (i>maxPlayers) 
			i=0;
		if (isAnEnemy(i))
			break;
	} while (i!=enemy);
	return i;
}

function countEnemies() {
	var ret=0;
	for (var i=0; i<maxPlayers; ++i)
		if (isAnEnemy(i))
			++ret;
	return ret;
}

// picks an enemy player to attack
function findEnemy() {
	var enemies=[];
	for (var i=0; i<maxPlayers; ++i)
		if (isAnEnemy(i))
			enemies[enemies.length]=i;
	return enemies[random(enemies.length)];
}

// make sure groups have their enemies defined
function pickEnemiesForGroups() {
	for (var i=0; i<NUM_GROUPS; ++i) 
		if (!isAnEnemy(groupEnemy[i]) || typeof(groupEnemy[i])=="undefined")
			groupEnemy[i] = findEnemy();
}

// finds an appropriate target within enemy (enemy=-1 to choose random enemy)
function findTarget(enemy) {
	if (enemy==-1)
		enemy=findEnemy();
	for (var i=attackTargets.length-1; i>=0; --i) {
		var structs=enumStruct(enemy, attackTargets[i]);
		if (structs.length > 0) {
			var idx=0, danger=Infinity;
			for (var j=0; j<structs.length; ++j) {
				d = dangerLevel(structs[j].x,structs[j].y)
				if (d<danger) {
					danger=d;
					idx=j;
				}
			}
			return structs[idx];
		}
	}
	var droids=enumDroid(enemy);
	if (droids.length > 0) {
		return droids[random(droids.length)];
	}
}

// a very naive way of finding where our units mostly are
function naiveFindClusters(list) {
	this.clusters=[];
	this.xav=[];
	this.yav=[];
	for (i=list.length-1; i>=0; --i) {
		var x=list[i].x,y=list[i].y;
		var found=false;
		for (var j=0; j<this.clusters.length; ++j) {
			if (distBetweenTwoPoints(this.xav[j],this.yav[j],x,y)<MAX_DISPERSE + list.length/10) {
				var n=this.clusters[j].length;
				this.clusters[j][n]=i;
				this.xav[j]=(n*this.xav[j]+x)/(n+1);
				this.yav[j]=(n*this.yav[j]+y)/(n+1);
				found=true;
				break;
			}
		}
		if (!found) {
			var n=this.clusters.length;
			this.clusters[n]=[i];
			this.xav[n]=x;
			this.yav[n]=y;
		}
	}
}


// for formation movement of groups
// returns false iff already in formation
function regroupWarriors(gr) {
	// don't bother doing this sort of thing in case of emergency
	if (status!=STATUS_NORMAL)
		return false;
	// too much units? we're too cool, no longer need to regroup ...
	if (groupSize(battleGroup[gr]) > NUM_WARRIORS)
		return false;
	// early rushy tanks need to be fast
	if (earlyGame(PEACE_TIME))
		return false;
	var list=enumGroup(battleGroup[gr]);
	var ret=new naiveFindClusters(list);
	// find biggest cluster
	var maxIdx=0, maxCount=0;
	for (var i=0; i<ret.clusters.length; ++i) {
		var n=ret.clusters[i].length;
		if (n>maxCount) {
			maxCount = n;
			maxIdx = i;
		}
	}
	if (maxCount > NO_WARRIORS_AT_ALL) {
		for (var i=0; i<ret.clusters.length; ++i) 
			if (i!=maxIdx) 
				for (j=0; j<ret.clusters[i].length; ++j) 
					orderDroidLoc(list[ret.clusters[i][j]], DORDER_MOVE, ret.xav[maxIdx], ret.yav[maxIdx]);
	} else {
		var idx=random(list.length);
		for (var i=0; i<list.length; ++i)
			orderDroidLoc(list[i], DORDER_MOVE, list[idx].x,list[idx].y);
	}
	return (maxCount < MIN_WARRIORS);
}

// forces a regroup for all warrior groups that are actually dispersed
function forceRegroup() {
	for (var i=0; i<NUM_GROUPS; ++i)
		regroupWarriors(i);
}

// the attack
function attackStuff() {
	// don't bother doing this sort of thing in case of emergency
	if (status==STATUS_PANIC)
		return;
	pickEnemiesForGroups();
	for (var gr=0; gr<NUM_GROUPS; ++gr) {
		var attackers=enumGroup(battleGroup[gr]);
		if (groupSize(battleGroup[gr]) >= MIN_WARRIORS || earlyGame(5)) {
			if (regroupWarriors(gr))
				continue;
			var target=findTarget(groupEnemy[gr]);
			if (typeof(target) != "undefined") 
				for (var i=0; i<attackers.length; ++i)
					if (!sendForRepair(attackers[i]))
						if (attackers[i].order != DORDER_SCOUT)
							orderDroidLoc(attackers[i], DORDER_SCOUT, target.x, target.y);
		} 
	}
}

// attack things with VTOLs
function vtolAttack() {
	if (!THIS_AI_MAKES_VTOLS)
		return;
	for (var gr=0; gr<NUM_VTOL_GROUPS; ++gr) {
		if (groupSize(vtolGroup[gr])<MIN_VTOLS)
			return;
		var vtols=enumGroup(vtolGroup[gr]);
		var target=findTarget(-1);
		if (typeof(target) != "undefined") {
			var list=[];
			for (var i=0; i<vtols.length; ++i)
				if (vtols[i].order != DORDER_ATTACK && vtols[i].armed == 100)
					list[list.length]=i;
			if (list.length>=MIN_VTOLS)
				for (var i=0; i<list.length; ++i) 
					orderDroidObj(vtols[list[i]], DORDER_ATTACK, target);
		}
	}
}

	/**********/
	/* Events */
	/**********/

function eventResearched(tech, labparam) {
	queue("doResearch");
	queue("executeBuildOrder");
	queue("upgradeStructures");
}

function eventStructureBuilt(struct, droid) {
	buildIncompleteBuildings();
	queue("executeBuildOrder");
	queue("huntForOil");
	queue("upgradeStructures");
	queue("produceDroids");
	queue("doResearch");
}

function eventDroidBuilt(droid, struct) {
	if (droid.player != me)
		return;
	if (isVTOL(droid))
		addVtolToSomeGroup(droid);
	else if (droid.droidType == DROID_CONSTRUCT) {
			addTruckToSomeGroup(droid);
			queue("executeBuildOrder");
			queue("huntForOil");
	} else 
		addTankToSomeGroup(droid);
	queue("produceDroids");
}

function eventAttacked(victim, attacker) {
	if (!isAnEnemy(attacker.player))
		return;
	if (attacker.type == DROID) 
		if (isVTOL(attacker)) {
			buildTower(victim.x,victim.y,antiair);
			return;
		}
	if (attacker.type == STRUCTURE)
		setStatus(STATUS_UNDER_ARTY_FIRE);
	if (victim.type == DROID) {
		if (isVTOL(victim)) {
			if (!needsRepair(victim))
				if (victim.armed > 0)
					orderDroidObj(victim, DORDER_ATTACK, attacker);
			return;
		}
		if (victim.droidType == DROID_WEAPON || victim.droidType == DROID_CYBORG) {
			var gr=groupOfTank(victim);
			var attackers=enumGroup(battleGroup[gr]);
			for (var i=0; i<attackers.length; ++i)
				if (!sendForRepair(attackers[i]))
					orderDroidObj(attackers[i], DORDER_ATTACK, attacker);
			sendForRepair(victim);
			return;
		} else 
			if (victim.health < 80 || victim.order != DORDER_BUILD)
				sendForRepair(victim);
	} else {
		for (gr=0; gr<NUM_GROUPS; ++gr) 
			if (groupEnemy[gr] == attacker.player || status==STATUS_PANIC) {
				if (regroupWarriors(gr) && status==STATUS_NORMAL) 
					continue;
				var attackers=enumGroup(battleGroup[gr]);
				for (var i=0; i<attackers.length; ++i)
					if (!sendForRepair(attackers[i]))
						orderDroidObj(attackers[i], DORDER_ATTACK, attacker);
			}
	}
}

// laser satellite strike
function eventStructureReady(structure) {
	activateStructure(structure,findTarget(-1));
}

function detectUnusualSituation() {
	// HACK: find a better way to find out if we are in challenge
	if (playerPower(me)<1000 || playerPower(me) > 3300) 
		UNUSUAL_SITUATION = true;
}

function eventStartLevel() {
	queue("detectUnusualSituation");
	if (baseType != CAMP_CLEAN)
		PEACE_TIME=0;
	builderGroup=newGroup();
	oilerGroup=newGroup();
	battleGroup[0]=newGroup();
	groupEnemy[0]=findEnemy();
	NUM_GROUPS = MIN_GROUPS;
	for (i=1; i<NUM_GROUPS; ++i) {
		battleGroup[i]=newGroup();
		groupEnemy[i]=nextEnemy(groupEnemy[i-1]);
	}
	NUM_VTOL_GROUPS = MIN_VTOL_GROUPS;
	for (i=0; i<NUM_VTOL_GROUPS; ++i)
		vtolGroup[i]=newGroup();
	var trucks = enumDroid(me, DROID_CONSTRUCT);
	for (var i=0; i<trucks.length; ++i) {
		addTruckToSomeGroup(trucks[i]);
	}
	queue("executeBuildOrder");
	setTimer("updateStatus",		5000);
	setTimer("huntForOil", 		7000);
	setTimer("produceDroids", 		10000);
	setTimer("doResearch", 		10000);
	setTimer("executeBuildOrder",	3000);
	setTimer("attackStuff",		10000);
	setTimer("upgradeStructures",	10000);
	setTimer("vtolAttack",		5000);
	setTimer("cheat",			30000);
	setTimer("becomeHarder",		480000);
	setTimer("adapt",			60000);
	setTimer("tooManyGroups",		30000);
	setTimer("forceRegroup",		20000);
	setTimer("buildIncompleteBuildings",		3000);
	setTimer("sendAllForRepair",		5000);
}
